#ifndef __MATVEC_GTO_CSC_CSR_KERNELS_H__
#define __MATVEC_GTO_CSC_CSR_KERNELS_H__


#define __MY_RESTRICT__ __restrict__
#define NCASES_GTO 31

#ifdef __TEST_CPU__

void
matVec_GTO_CSC_CSR_CPU
(
  idx_k M, // = m_IO.matSize();
  // const void* * jumps,
  unsigned char const * const  __restrict__ nnzList,
  idx_k         const * const  __restrict__ o, //=Permutation.pOwner();
  idx_k         const * const  __restrict__ uPtr, //=Permutation.pNeigh();
  LDUoffDiag_k  const * const  __restrict__ upperPtr, //=Permutation.upper( randomMatrix.upper() );
  LDUoffDiag_k  const * const  __restrict__ lowerPtr, //=Permutation.lower( randomMatrix.lower() );
  fld_k         const * const  __restrict__ psiPtr, //=Permutation.x(     randomMatrix.x()     );
  fld_k               * const  __restrict__ ApsiPtr  //=m_result;
)
{
  static const void* jumpList[] = {&&s0, &&s1, &&s2, &&s3, &&s4, &&s5, &&s6, &&s7, &&s8, &&s9, &&s10, &&s11, &&s12, &&s13, &&s14, &&s15, &&s16,
                                   &&s17, &&s18, &&s19, &&s20, &&s21, &&s22, &&s23, &&s24, &&s25, &&s26, &&s27, &&s28, &&s29, &&s30, &&send};
  
  /*for (idx_k i=0; i<M; ++i) 
  {
    jumps[i] = jumpList[blkKind[i]];
  }
  int lenJumpList = sizeof(jumpList)/sizeof(const void*);
  jumps[M] = jumpList[lenJumpList - 1];*/

  #include "matMultGoTo.H"

  return;

};
#endif

#ifdef __TEST_NATIVE_CUDA__
__global__
void
matVec_GTO_CSC_CSR_nativeCUDA
(
    const idx_k                               nCells,
    const idx_k                               nFaces,
    const idx_k                               nInternalFaces,
    const idx_k                               cellsStride,
    const idx_k                               facesStride,
    const idx_k                               iComp,
    const idx_k*        const __MY_RESTRICT__ owner,
    const idx_k*        const __MY_RESTRICT__ neigh,
    const LDUoffDiag_k* const __MY_RESTRICT__ upper,
    const LDUoffDiag_k* const __MY_RESTRICT__ lower,
    const fld_k*        const __MY_RESTRICT__ psi,
          fld_k*        const __MY_RESTRICT__ Apsi
)
{
  return;
};
#endif


#ifdef __TEST_OPEN_ACC__
void
matVec_GTO_CSC_CSR_openACC
(
    const idx_k                               nCells,
    const idx_k                               nFaces,
    const idx_k                               nInternalFaces,
    const idx_k                               cellsStride,
    const idx_k                               facesStride,
    const idx_k                               iComp,
    const idx_k*        const __MY_RESTRICT__ owner,
    const idx_k*        const __MY_RESTRICT__ neigh,
    const LDUoffDiag_k* const __MY_RESTRICT__ upper,
    const LDUoffDiag_k* const __MY_RESTRICT__ lower,
    const fld_k*        const __MY_RESTRICT__ psi,
          fld_k*        const __MY_RESTRICT__ Apsi
)
{
  return;
};
#endif

#ifdef __TEST_OPEN_MP__
void
matVec_GTO_CSC_CSR_openMP
(
    const idx_k                               nCells,
    const idx_k                               nFaces,
    const idx_k                               nInternalFaces,
    const idx_k                               cellsStride,
    const idx_k                               facesStride,
    const idx_k                               iComp,
    const idx_k*        const __MY_RESTRICT__ owner,
    const idx_k*        const __MY_RESTRICT__ neigh,
    const LDUoffDiag_k* const __MY_RESTRICT__ upper,
    const LDUoffDiag_k* const __MY_RESTRICT__ lower,
    const fld_k*        const __MY_RESTRICT__ psi,
          fld_k*        const __MY_RESTRICT__ Apsi
)
{
  return;
};
#endif

#endif
