from jinja2 import Environment, FileSystemLoader
import os


### Blocks definition ###
# cases = [["s", 20]]
mNnz = 0   # Max number of nnz for block of 3 or 2 rows
bMnnz = 0  # Max number of nnz for block of at least 3 rows and max mNrows
mNrows = 0 # Max number of rows in a block with the same nnz
sMnnz = 30 # Max number of nnz in single row blocks

cases = []
## loop for blocks of 3 rows
for i in range(0, mNnz+1):
    for j in range(0, mNnz+1):
        for h in range(0, mNnz+1):
            cases.append(["t", i, j, h])

## loop for blocks of 2 rows
for i in range(0, mNnz+1):
    for j in range(0, mNnz+1):
        cases.append(["d", i, j])

## loop for blocks of 1 row
for i in range(0, sMnnz+1):
    cases.append(["s", i])

## loop for unrolled blocks
for i in range(2, mNrows+1):
    for j in range(0, bMnnz+1):
        cases.append(["b", i, "x", j])

print(f"Number of blocks: {len(cases)}")

### Kernel generation ###
includePath = "../src/matVec/GTO_CSC_CSR/"
finalFile =  "matMultGoTo.H"

environment = Environment(loader=FileSystemLoader("."))
template = environment.get_template("template_matMultGoTo.H.jinja")

content = template.render(cases=cases)

with open(os.path.join(includePath, finalFile), "w") as final:
    final.write(content)